// Gregs PRUSA Mendel  
// X-carriage
// Used for sliding on X axis
// GNU GPL v2
// Greg Frost
//https://github.com/GregFrost/PrusaMendel

include <configuration.scad>

clearance=0.7;

lm8uu_diameter=15+clearance;
lm8uu_length=24+clearance;
lm8uu_support_thickness=3.2; 
lm8uu_support_ext_width=1.0; 
lm8uu_holder_gap_add=-1.2;

lm8uu_end_diameter=m8_diameter+1.5;

lm8uu_holder_width=lm8uu_diameter+2*lm8uu_support_thickness + lm8uu_support_ext_width;
lm8uu_holder_length=lm8uu_length+2*lm8uu_support_thickness;
lm8uu_holder_height=lm8uu_diameter*0.75+lm8uu_support_thickness;
lm8uu_holder_gap=(lm8uu_holder_length-6*lm8uu_support_thickness)/2;

module lm8uu_bearing_holder(cut=0,side=0)
{
	difference()
	{
        translate([lm8uu_holder_width/2, lm8uu_holder_length/2, lm8uu_holder_height/2-0.5])
        minkowski()
        {
  			cube([lm8uu_holder_width-8,lm8uu_holder_length-8,lm8uu_holder_height-1], center=true);
            cylinder(r=4,h=1,$fn=50);
        }
		translate([lm8uu_holder_width/2,0,lm8uu_holder_width/2])
		rotate([-90,0,0])
		translate([0,0,lm8uu_support_thickness-(side+1)*cut/2])
		cylinder(r=lm8uu_diameter/2,h=lm8uu_length+cut,$fn=40);

		translate([lm8uu_holder_width/2,0,lm8uu_holder_width/2])
		rotate([-90,0,0])
		translate([0,0,-1])
		{
			cylinder(r=lm8uu_end_diameter/2,h=lm8uu_holder_length+2,$fn=40);
			translate([-lm8uu_end_diameter/2,-lm8uu_end_diameter,0])
			cube([lm8uu_end_diameter,lm8uu_end_diameter,lm8uu_holder_length+2]);
		}

		translate([-1,2*lm8uu_support_thickness-lm8uu_holder_gap_add/2,lm8uu_support_thickness])
		cube([lm8uu_holder_width+2,lm8uu_holder_gap+lm8uu_holder_gap_add,
			lm8uu_holder_height-lm8uu_support_thickness+1]);

		translate([-1,4*lm8uu_support_thickness+lm8uu_holder_gap-lm8uu_holder_gap_add/2,
			lm8uu_support_thickness])
		cube([lm8uu_holder_width+2,lm8uu_holder_gap+lm8uu_holder_gap_add,
			lm8uu_holder_height-lm8uu_support_thickness+1]);

        translate([0, (-side+1)*(lm8uu_holder_length/2-cut/2), 0])
        cube([lm8uu_holder_width, cut, lm8uu_holder_height]);

	}
}

module lm8uu_bearing_rod_path()
{
	translate([lm8uu_holder_width/2,0,lm8uu_holder_width/2])
	rotate([-90,0,0])
	translate([0,0,-20])
	cylinder(r=lm8uu_end_diameter/2,h=lm8uu_holder_length+40,$fn=40);
}
